Build your web apps using Smart UI Library
Smart.Editor - Context Menu
Editor Context Menu
Smart.Editor has a built in context menu that is available by default. When the user right clicks with the mouse inside the Editor, the context menu opens. A different options list is displayed depending on the target. However the options list can be customized.
The contextMenu property determines the behavior of the Editor's context menu. It is possible to use the native context menu instead of the Editor's built in or event disable the context menus inside the element.
Here's how to enable the browser's context menu in order to used it instead of the built in:
document.querySelector('smart-editor').contextMenu = 'browser';
Let's take a close look at the built in Context menu options.
Table Context Menu
When the user triggers the context menu on a Table cell element inside the Editor a specific options list appears that allows to execute quick actions like:
- Edit the Table Properties
- Insert new rows/columns
- Delete rows/columns
- Delete the whole table
Image Context Menu
Image elements inside the Editor also offer specific context menu options:
- Edit Image Properties
- Copy/Cut the image
- Add/Remove a hyperlink
- Add/Remove a caption
Link Context Menu
Hyperlink elements inside the Editor also have specific context menu options:
- Editor the Link properties
- Delete the link
Text Context Menu
Clicking anywhere else inside the Editor's content will trigger the default context menu for text.
The default context menu options offer basic quick actions like copy, paste, cut and text selection
Custom Context Menu
The Context menu options can be customized. The user can specify a list of completely different quick action items even for specific targets.
It is also possible to modify the default options list and remove specific options that the user does not want to have or include additional.
The contextMenuDataSource property allows to modify the options list of the context menu. It accepts an array of strings or objects with the following format
{ label: string, value: string }
If the list option is a string it is used as the label and value for the item. When defined as objects the user can set a one label to an option while it has a different value.
The contextMenuDataSource also accepts a function with the following format:
function (target: HTMLElement, type: string, defaultItems: string[]) { return defaultItems }
When the property is a function it is possible to modify the default options list instead of replacing
it. The defaultItems is an array that contains the options for the context menu that will be
displayed. The type parameter represents the type of the context menu (table, image, link or
text). The function is executed before the context menu is opened.
The following demo shows to to add a custom context menu item that deletes everything inside the Editor:
window.Smart('#editor', class {
get properties() {
return {
//Properties
contextMenuDataSource: function (target, type, defaultItems) {
if (type === 'table') {
defaultItems.splice(defaultItems.indexOf('deleteTable'), 1);
defaultItems.splice(defaultItems.indexOf('deleteRow'), 1);
defaultItems.splice(defaultItems.indexOf('deleteColumn'), 1);
}
if (!defaultItems.find(i => typeof i === 'object' && i.value === 'custoItem1')) {
defaultItems.push({
label: 'Custom Delete All Item',
value: 'customItem1'
});
}
return defaultItems;
}
};
}
});
The context menu fires a contextMenuItemClick event which contains the value of the selected item. This way it is possible to execute a custom logic when a certain item has been clicked.
For AI tooling
Developer Quick Reference
Topic: editor-context-menu Component: Editor Framework: JavaScript
Main methods: (none detected)
Common config keys: (none detected)
Implementation Notes
Compatibility: Modern browsers / Web Components API access pattern: const component = document.querySelector(...) + component.method()
Lifecycle guidance: Initialize configuration first, then invoke imperative API when element is available in DOM.
Common pitfalls:
- Calling methods before element initialization.
- Reassigning large configuration partially without understanding merge behavior.
- Missing required module script import for component type.
Validation checklist:
- Ensure module scripts and CSS are loaded once.
- Keep data schema aligned with columns/series definitions.
- Verify method calls target initialized component instance.

Smart.Editor Context Menu

Editor for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.editor.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-editor ref="component"></smart-editor>
</template>

Use component.value for API methods in this topic.

Editor Context Menu

Smart.Editor has a built in context menu that is available by default. When the user right clicks with the mouse inside the Editor, the context menu opens. A different options list is displayed depending on the target. However the options list can be customized.

The contextMenu property determines the behavior of the Editor's context menu. It is possible to use the native context menu instead of the Editor's built in or event disable the context menus inside the element.

Here's how to enable the browser's context menu in order to used it instead of the built in:

component.value.contextMenu = 'browser';

Let's take a close look at the built in Context menu options.

Table Context Menu

When the user triggers the context menu on a Table cell element inside the Editor a specific options list appears that allows to execute quick actions like:

  • Edit the Table Properties
  • Insert new rows/columns
  • Delete rows/columns
  • Delete the whole table
Editor Context Menu

Image Context Menu

Image elements inside the Editor also offer specific context menu options:

  • Edit Image Properties
  • Copy/Cut the image
  • Add/Remove a hyperlink
  • Add/Remove a caption
Editor Context Menu 2

Link Context Menu

Hyperlink elements inside the Editor also have specific context menu options:

  • Editor the Link properties
  • Delete the link
Editor Context Menu 3

Text Context Menu

Clicking anywhere else inside the Editor's content will trigger the default context menu for text.

The default context menu options offer basic quick actions like copy, paste, cut and text selection

Editor Context Menu 4

Custom Context Menu

The Context menu options can be customized. The user can specify a list of completely different quick action items even for specific targets.

It is also possible to modify the default options list and remove specific options that the user does not want to have or include additional.

The contextMenuDataSource property allows to modify the options list of the context menu. It accepts an array of strings or objects with the following format

{ label: string, value: string }

If the list option is a string it is used as the label and value for the item. When defined as objects the user can set a one label to an option while it has a different value.

The contextMenuDataSource also accepts a function with the following format:

function (target: HTMLElement, type: string, defaultItems: string[]) { return defaultItems }
When the property is a function it is possible to modify the default options list instead of replacing it. The defaultItems is an array that contains the options for the context menu that will be displayed. The type parameter represents the type of the context menu (table, image, link or text). The function is executed before the context menu is opened.

The following demo shows to to add a custom context menu item that deletes everything inside the Editor:

const componentProps = {
            //Properties
            contextMenuDataSource: function (target, type, defaultItems) {
                if (type === 'table') {
                    defaultItems.splice(defaultItems.indexOf('deleteTable'), 1);
                    defaultItems.splice(defaultItems.indexOf('deleteRow'), 1);
                    defaultItems.splice(defaultItems.indexOf('deleteColumn'), 1);
                }
                if (!defaultItems.find(i => typeof i === 'object' && i.value === 'custoItem1')) {
                    defaultItems.push({
                        label: 'Custom Delete All Item',
                        value: 'customItem1'
                    });
                }
                return defaultItems;
            }
};

The context menu fires a contextMenuItemClick event which contains the value of the selected item. This way it is possible to execute a custom logic when a certain item has been clicked.

Editor Context Menu 5
For AI tooling

Developer Quick Reference

Topic: editor-context-menu   Component: Editor   Framework: Vue

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with

Smart.Editor Context Menu

Editor for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Editor } from 'smart-webcomponents-react/editor';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Editor ref={componentRef} {...componentProps}></Editor>;
}

Use componentRef.current for API methods in this topic.

Editor Context Menu

Smart.Editor has a built in context menu that is available by default. When the user right clicks with the mouse inside the Editor, the context menu opens. A different options list is displayed depending on the target. However the options list can be customized.

The contextMenu property determines the behavior of the Editor's context menu. It is possible to use the native context menu instead of the Editor's built in or event disable the context menus inside the element.

Here's how to enable the browser's context menu in order to used it instead of the built in:

componentRef.current.contextMenu = 'browser';

Let's take a close look at the built in Context menu options.

Table Context Menu

When the user triggers the context menu on a Table cell element inside the Editor a specific options list appears that allows to execute quick actions like:

  • Edit the Table Properties
  • Insert new rows/columns
  • Delete rows/columns
  • Delete the whole table
Editor Context Menu

Image Context Menu

Image elements inside the Editor also offer specific context menu options:

  • Edit Image Properties
  • Copy/Cut the image
  • Add/Remove a hyperlink
  • Add/Remove a caption
Editor Context Menu 2

Link Context Menu

Hyperlink elements inside the Editor also have specific context menu options:

  • Editor the Link properties
  • Delete the link
Editor Context Menu 3

Text Context Menu

Clicking anywhere else inside the Editor's content will trigger the default context menu for text.

The default context menu options offer basic quick actions like copy, paste, cut and text selection

Editor Context Menu 4

Custom Context Menu

The Context menu options can be customized. The user can specify a list of completely different quick action items even for specific targets.

It is also possible to modify the default options list and remove specific options that the user does not want to have or include additional.

The contextMenuDataSource property allows to modify the options list of the context menu. It accepts an array of strings or objects with the following format

{ label: string, value: string }

If the list option is a string it is used as the label and value for the item. When defined as objects the user can set a one label to an option while it has a different value.

The contextMenuDataSource also accepts a function with the following format:

function (target: HTMLElement, type: string, defaultItems: string[]) { return defaultItems }
When the property is a function it is possible to modify the default options list instead of replacing it. The defaultItems is an array that contains the options for the context menu that will be displayed. The type parameter represents the type of the context menu (table, image, link or text). The function is executed before the context menu is opened.

The following demo shows to to add a custom context menu item that deletes everything inside the Editor:

const componentProps = useMemo(() => ({
            //Properties
            contextMenuDataSource: function (target, type, defaultItems) {
                if (type === 'table') {
                    defaultItems.splice(defaultItems.indexOf('deleteTable'), 1);
                    defaultItems.splice(defaultItems.indexOf('deleteRow'), 1);
                    defaultItems.splice(defaultItems.indexOf('deleteColumn'), 1);
                }
                if (!defaultItems.find(i => typeof i === 'object' && i.value === 'custoItem1')) {
                    defaultItems.push({
                        label: 'Custom Delete All Item',
                        value: 'customItem1'
                    });
                }
                return defaultItems;
            }
}), []);

The context menu fires a contextMenuItemClick event which contains the value of the selected item. This way it is possible to execute a custom logic when a certain item has been clicked.

Editor Context Menu 5
For AI tooling

Developer Quick Reference

Topic: editor-context-menu   Component: Editor   Framework: React

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Smart.Editor Context Menu

Editor for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { EditorComponent, EditorModule } from 'smart-webcomponents-angular/editor';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, EditorModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('editor', { read: EditorComponent, static: false }) editor!: EditorComponent;
}
<!-- app.component.html -->
<smart-editor #editor></smart-editor>

Use this.editor for API methods in this topic.

Editor Context Menu

Smart.Editor has a built in context menu that is available by default. When the user right clicks with the mouse inside the Editor, the context menu opens. A different options list is displayed depending on the target. However the options list can be customized.

The contextMenu property determines the behavior of the Editor's context menu. It is possible to use the native context menu instead of the Editor's built in or event disable the context menus inside the element.

Here's how to enable the browser's context menu in order to used it instead of the built in:

this.editor.contextMenu = 'browser';

Let's take a close look at the built in Context menu options.

Table Context Menu

When the user triggers the context menu on a Table cell element inside the Editor a specific options list appears that allows to execute quick actions like:

  • Edit the Table Properties
  • Insert new rows/columns
  • Delete rows/columns
  • Delete the whole table
Editor Context Menu

Image Context Menu

Image elements inside the Editor also offer specific context menu options:

  • Edit Image Properties
  • Copy/Cut the image
  • Add/Remove a hyperlink
  • Add/Remove a caption
Editor Context Menu 2

Link Context Menu

Hyperlink elements inside the Editor also have specific context menu options:

  • Editor the Link properties
  • Delete the link
Editor Context Menu 3

Text Context Menu

Clicking anywhere else inside the Editor's content will trigger the default context menu for text.

The default context menu options offer basic quick actions like copy, paste, cut and text selection

Editor Context Menu 4

Custom Context Menu

The Context menu options can be customized. The user can specify a list of completely different quick action items even for specific targets.

It is also possible to modify the default options list and remove specific options that the user does not want to have or include additional.

The contextMenuDataSource property allows to modify the options list of the context menu. It accepts an array of strings or objects with the following format

{ label: string, value: string }

If the list option is a string it is used as the label and value for the item. When defined as objects the user can set a one label to an option while it has a different value.

The contextMenuDataSource also accepts a function with the following format:

function (target: HTMLElement, type: string, defaultItems: string[]) { return defaultItems }
When the property is a function it is possible to modify the default options list instead of replacing it. The defaultItems is an array that contains the options for the context menu that will be displayed. The type parameter represents the type of the context menu (table, image, link or text). The function is executed before the context menu is opened.

The following demo shows to to add a custom context menu item that deletes everything inside the Editor:

componentOptions = {
            //Properties
            contextMenuDataSource: function (target, type, defaultItems) {
                if (type === 'table') {
                    defaultItems.splice(defaultItems.indexOf('deleteTable'), 1);
                    defaultItems.splice(defaultItems.indexOf('deleteRow'), 1);
                    defaultItems.splice(defaultItems.indexOf('deleteColumn'), 1);
                }
                if (!defaultItems.find(i => typeof i === 'object' && i.value === 'custoItem1')) {
                    defaultItems.push({
                        label: 'Custom Delete All Item',
                        value: 'customItem1'
                    });
                }
                return defaultItems;
            }
};

The context menu fires a contextMenuItemClick event which contains the value of the selected item. This way it is possible to execute a custom logic when a certain item has been clicked.

Editor Context Menu 5
For AI tooling

Developer Quick Reference

Topic: editor-context-menu   Component: Editor   Framework: Angular

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.